Botan 1.10.17

Public Member Functions | List of all members
Botan::Cascade_Cipher Class Reference

`#include <cascade.h>`

Inheritance diagram for Botan::Cascade_Cipher:

## Public Member Functions
size_t | block_size () const
| Cascade_Cipher (BlockCipher *cipher1, BlockCipher *cipher2)
void | clear ()
BlockCipher * | clone () const
void | decrypt (const byte in[], byte out[]) const
void | decrypt (byte block[]) const
void | decrypt_n (const byte in[], byte out[], size_t blocks) const
void | encrypt (const byte in[], byte out[]) const
void | encrypt (byte block[]) const
void | encrypt_n (const byte in[], byte out[], size_t blocks) const
Key_Length_Specification | key_spec () const
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
size_t | parallel_bytes () const
virtual size_t | parallelism () const
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
bool | valid_keylength (size_t length) const
| ~Cascade_Cipher ()

## Detailed Description

Block Cipher Cascade

Definition at line 18 of file cascade.h.

## Constructor & Destructor Documentation

## ◆ Cascade_Cipher()

Botan::Cascade_Cipher::Cascade_Cipher | ( | BlockCipher * | cipher1,
|  | BlockCipher * | cipher2
| ) |  |

Create a cascade of two block ciphers

Parameters

  cipher1 | the first cipher
  cipher2 | the second cipher

Definition at line 83 of file cascade.cpp.

References block_size(), Botan::BlockCipher::block_size(), and name().

Referenced by clone().

83 :
84 cipher1(c1), cipher2(c2)
85 {
86 block = block_size_for_cascade(c1->block_size(), c2->block_size());
87
88 if(block_size() % c1->block_size() || block_size() % c2->block_size())
89 throw Internal_Error("Failure in " + name() + " constructor");
90 }
Botan::Cascade_Cipher::name
std::string name() const
Definition: cascade.cpp:46
Botan::Cascade_Cipher::block_size
size_t block_size() const
Definition: cascade.h:24

## ◆ ~Cascade_Cipher()

Botan::Cascade_Cipher::~Cascade_Cipher | ( |  | ) |

Definition at line 92 of file cascade.cpp.

93 {
94 delete cipher1;
95 delete cipher2;
96 }

## Member Function Documentation

## ◆ block_size()

size_t Botan::Cascade_Cipher::block_size | ( |  | ) | const
| inline virtual

Returns
  block size of this algorithm

Implements Botan::BlockCipher.

Definition at line 24 of file cascade.h.

Referenced by Cascade_Cipher(), decrypt_n(), and encrypt_n().

24 { return block; }

## ◆ clear()

void Botan::Cascade_Cipher::clear | ( |  | ) |
| virtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 40 of file cascade.cpp.

References Botan::Algorithm::clear().

41 {
42 cipher1->clear();
43 cipher2->clear();
44 }
Botan::Algorithm::clear
virtual void clear()=0

## ◆ clone()

BlockCipher * Botan::Cascade_Cipher::clone | ( |  | ) | const
| virtual

Get a new object representing the same algorithm as *this

Implements Botan::BlockCipher.

Definition at line 51 of file cascade.cpp.

References Cascade_Cipher(), and Botan::BlockCipher::clone().

52 {
53 return new Cascade_Cipher(cipher1->clone(),
54 cipher2->clone());
55 }
Botan::BlockCipher::clone
virtual BlockCipher * clone() const =0
Botan::Cascade_Cipher::Cascade_Cipher
Cascade_Cipher(BlockCipher *cipher1, BlockCipher *cipher2)
Definition: cascade.cpp:83

## ◆ decrypt() [1/2]

void Botan::BlockCipher::decrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inline inherited

Decrypt a block.

Parameters

  in | The ciphertext block to be decypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the decrypted block. Must be of length block_size().

Definition at line 57 of file block_cipher.h.

Referenced by Botan::DESX::decrypt_n().

58 { decrypt_n(in, out, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt() [2/2]

void Botan::BlockCipher::decrypt | ( | byte | block[] | ) | const
| inline inherited

Decrypt a block.

Parameters

  block | the ciphertext block to be decrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 74 of file block_cipher.h.

74 { decrypt_n(block, block, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt_n()

void Botan::Cascade_Cipher::decrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Decrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 22 of file cascade.cpp.

References block_size(), Botan::BlockCipher::block_size(), and Botan::BlockCipher::decrypt_n().

24 {
25 size_t c1_blocks = blocks * (block_size() / cipher1->block_size());
26 size_t c2_blocks = blocks * (block_size() / cipher2->block_size());
27
28 cipher2->decrypt_n(in, out, c2_blocks);
29 cipher1->decrypt_n(out, out, c1_blocks);
30 }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0
Botan::BlockCipher::block_size
virtual size_t block_size() const =0
Botan::Cascade_Cipher::block_size
size_t block_size() const
Definition: cascade.h:24

## ◆ encrypt() [1/2]

void Botan::BlockCipher::encrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inline inherited

Encrypt a block.

Parameters

  in | The plaintext block to be encrypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the encrypted block. Must be of length block_size().

Definition at line 47 of file block_cipher.h.

Referenced by Botan::aont_unpackage(), Botan::OFB::cipher(), Botan::DESX::encrypt_n(), Botan::OFB::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::XTS_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), and Botan::XTS_Decryption::set_iv().

48 { encrypt_n(in, out, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt() [2/2]

void Botan::BlockCipher::encrypt | ( | byte | block[] | ) | const
| inline inherited

Encrypt a block.

Parameters

  block | the plaintext block to be encrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 66 of file block_cipher.h.

66 { encrypt_n(block, block, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt_n()

void Botan::Cascade_Cipher::encrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Encrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 12 of file cascade.cpp.

References block_size(), Botan::BlockCipher::block_size(), and Botan::BlockCipher::encrypt_n().

14 {
15 size_t c1_blocks = blocks * (block_size() / cipher1->block_size());
16 size_t c2_blocks = blocks * (block_size() / cipher2->block_size());
17
18 cipher1->encrypt_n(in, out, c1_blocks);
19 cipher2->encrypt_n(out, out, c2_blocks);
20 }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0
Botan::BlockCipher::block_size
virtual size_t block_size() const =0
Botan::Cascade_Cipher::block_size
size_t block_size() const
Definition: cascade.h:24

## ◆ key_spec()

Key_Length_Specification Botan::Cascade_Cipher::key_spec | ( |  | ) | const
| inline virtual

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 26 of file cascade.h.

27 {
28 return Key_Length_Specification(cipher1->maximum_keylength() +
29 cipher2->maximum_keylength());
30 }
Botan::SymmetricAlgorithm::maximum_keylength
size_t maximum_keylength() const
Definition: sym_algo.h:33

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inline inherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inline inherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

## ◆ name()

std::string Botan::Cascade_Cipher::name | ( |  | ) | const
| virtual

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 46 of file cascade.cpp.

References Botan::Algorithm::name().

Referenced by Cascade_Cipher().

47 {
48 return "Cascade(" + cipher1->name() + "," + cipher2->name() + ")";
49 }
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ parallel_bytes()

size_t Botan::BlockCipher::parallel_bytes | ( |  | ) | const
| inline inherited

Returns
  prefererred parallelism of this cipher in bytes

Definition at line 35 of file block_cipher.h.

36 {
37 return parallelism() * block_size() * BOTAN_BLOCK_CIPHER_PAR_MULT;
38 }
Botan::BlockCipher::parallelism
virtual size_t parallelism() const
Definition: block_cipher.h:30
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

## ◆ parallelism()

virtual size_t Botan::BlockCipher::parallelism | ( |  | ) | const
| inline virtual inherited

Returns
  native parallelism of this cipher in blocks

Reimplemented in Botan::AES_256_NI, Botan::AES_192_NI, Botan::AES_128_NI, Botan::IDEA_SSE2, Botan::Noekeon_SIMD, Botan::Serpent_SIMD, and Botan::XTEA_SIMD.

Definition at line 30 of file block_cipher.h.

30 { return 1; }

## ◆ set_key() [1/2]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_unpackage(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::HMAC_RNG::reseed(), Botan::XTS_Encryption::set_key(), Botan::EAX_Base::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), and Botan::StreamCipher_Filter::StreamCipher_Filter().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ set_key() [2/2]

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), and Botan::Lion::Lion().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

The documentation for this class was generated from the following files:

- src/block/cascade/cascade.h
- src/block/cascade/cascade.cpp